;
; plugin.asm
; Bumblebee <bbbee@mailcity.com>
;
; Description:
;
;  It just shows a messagebox. It's a PROVIDE_APP plugin.
;
;
.486p
locals
jumps
public DllEntryPoint
.model flat,STDCALL

extrn GetProcAddress:PROC
extrn    MessageBoxA:PROC

; for DllEntryPoint
DLL_PROCESS_ATTACH      equ     1
DLL_THREAD_ATTACH       equ     2
DLL_THREAD_DETACH       equ     3
DLL_PROCESS_DETACH      equ     0

PROVIDE_APP             equ     0               ; generic
PROVIDE_INSTALL         equ     1               ; requires dropper
PROVIDE_INFECT          equ     2               ; requires filename

PluginObject    struc
po_idNumber     dd      ?                       ; identification number
po_version      dd      ?                       ; version
po_provides     dd      ?                       ; provides consts
po_api          dd      ?                       ; addr of provided api
PluginObject    ends

; plugin consts
IDNUMBER        equ     'MSGB'
PVERSION        equ     1
PROVIDED        equ     PROVIDE_APP

.data

DllInit         dd      0
DllHinstance    dd      0

; plugin api data
ProvidedAPIStr  db      'api',0                 ; this name can change
ProvidedAPIAddr dd      ?

; plugin data
btitle          db      'Plugin output',0
bmess           db      'That message is from the DLL API.',0

.code
inicio:
;
; DllEntryPoint
;
;     hisntDLL: base address of the dll
;    fdwReason: reason of the call
;  lpvReserved: extra info for attach and detach
;
DllEntryPoint   proc    histDLL:DWORD, fdwReason:DWORD, lpvReserved:DWORD
        cmp     [fdwReason],DLL_PROCESS_ATTACH
        jne     @exit
        cmp     [DllInit],1
        je      @exit
;
; Here follows DLL init stuff
;
        mov     eax,[histDLL]
        mov     [DllHinstance],eax
        mov     [DllInit],1

        push    offset ProvidedAPIStr
        push    [DllHinstance]
        call    GetProcAddress
        mov     [ProvidedAPIAddr],eax
@exit:
        mov     eax,1
        ret
DllEntryPoint   endp

;
; Retrieves PluginObject info
;
; void PlugIt(DWORD lpPluginObject);
;
PlugIt  proc    lpPluginObject:DWORD
        mov     eax,[lpPluginObject]
        mov     [eax.po_idNumber],IDNUMBER
        mov     [eax.po_version],PVERSION
        mov     [eax.po_provides],PROVIDED
        mov     edx,[ProvidedAPIAddr]
        mov     [eax.po_api],edx
        ret
PlugIt  endp

;
; that's the api provided by the plugin
;
; void api(void);
;
api     proc

        push    1000h
        push    offset btitle
        push    offset bmess
        push    0h
        call    MessageBoxA
        
        ret
api     endp

;
; Default exported APIs
;
PUBLICDLL       PlugIt
PUBLICDLL       api

ends
end inicio

