;
; Plugin dll template
; Bumblebee <bbbee@mailcity.com>
;
;
; build with:
;
;       tasm32 /q /ml /m5 plugin,,;
;       tlink32 -Tpd -aa -c -x plugin,plugin,, import32.lib
;
; or better with:
;
;       tasm32 /q /ml /m5 plugin,,;
;       alink -oPE -dll plugin.obj win32.lib
;
;
.486p
locals
jumps
public DllEntryPoint
.model flat,STDCALL
include ../inc/plugin.inc

extrn GetProcAddress:PROC
; Here add your imports

; plugin consts
IDNUMBER        equ     'XXXX'                  ; put your id there
PVERSION        equ     1                       ; uh?
; You can put here:
;
; PROVIDE_APP
; -----------
;  That's for the generic plugin. Provides:
;
;       void api(void);
;
; PROVIDE_INSTALL
; ---------------
;  That's for the plugin that requires a dropper to run. Provides:
;
;       void api(DWORD lpBuffer, DWORD buffLen);
; 
; PROVIDE_INFECT
; --------------
;  That's for the plugin that requires a filename to run. Provides:
;
;       bool api(DWORD lpFilename); returns 0 on error
;
; You can define others as well.
;

PROVIDED        equ     ?

.data

; data needed for default DLL init
DllInit         dd      0
DllHinstance    dd      0

; plugin api data
ProvidedAPIStr  db      'api',0                 ; this name can change
ProvidedAPIAddr dd      ?

; plugin data follows

.code
inicio:
;
; DllEntryPoint
;
;     hisntDLL: base address of the dll
;    fdwReason: reason of the call
;  lpvReserved: extra info for attach and detach
;
DllEntryPoint   proc    histDLL:DWORD, fdwReason:DWORD, lpvReserved:DWORD
        cmp     [fdwReason],DLL_PROCESS_ATTACH
        jne     @exit
        cmp     [DllInit],1
        je      @exit
;
; Here follows DLL init stuff
;
        mov     eax,[histDLL]
        mov     [DllHinstance],eax
        mov     [DllInit],1

        push    offset ProvidedAPIStr
        push    [DllHinstance]
        call    GetProcAddress
        mov     [ProvidedAPIAddr],eax
;
; Add your init stuff there
;

@exit:
        mov     eax,1
        ret
DllEntryPoint   endp

;
; Retrieves PluginObject info
;
; void PlugIt(DWORD lpPluginObject);
;
PlugIt  proc    lpPluginObject:DWORD
        mov     eax,[lpPluginObject]
        mov     [eax.po_idNumber],IDNUMBER
        mov     [eax.po_version],PVERSION
        mov     [eax.po_provides],PROVIDED
        mov     edx,[ProvidedAPIAddr]
        mov     [eax.po_api],edx
        ret
PlugIt  endp

;
; that's the api provided by the plugin
;
; it can be:
;
; PROVIDE_APP:
;  api     proc
;
; PROVIDE_INSTALL:
;  api     proc    lpBuffer:DWORD, buffLen:DWORD
;
; PROVIDE_INFECT:
;  api     proc    lpFilename:DWORD
;
api     proc

;
; Put your code here.
;

        ret
api     endp

;
; Default exported APIs
;
PUBLICDLL       PlugIt
PUBLICDLL       api

ends
end inicio

