;
; DWORD CRC32(DWORD addr in,DWORD size);
;
CRC32 proc
        push    ebp
        mov     ebp,esp
        push    esi edi ecx edx ebx

        mov     esi,dword ptr [ebp+8]
        mov     edi,dword ptr [ebp+12]

	cld
        xor     ecx,ecx
        dec     ecx
	mov     edx,ecx
	push    ebx
NextByteCRC:
	xor     eax,eax
	xor     ebx,ebx
	lodsb
	xor     al,cl
	mov     cl,ch
	mov     ch,dl
	mov     dl,dh
	mov     dh,8
NextBitCRC:
	shr     bx,1
	rcr     ax,1
	jnc     NoCRC
	xor     ax,08320h
	xor     bx,0EDB8h
NoCRC:
        dec     dh
	jnz     NextBitCRC
	xor     ecx,eax
	xor     edx,ebx
        dec     edi
	jnz     NextByteCRC
	pop     ebx
	not     edx
	not     ecx
	mov     eax,edx
	rol     eax,16
	mov     ax,cx
        pop     ebx edx ecx edi esi
        pop     ebp
        retn    8
endp CRC32
